routes/web.php
<?php

use App\Http\Controllers\ActivationController;
use App\Http\Controllers\ActivityLogsController;
use App\Http\Controllers\LabelController;
use App\Http\Controllers\ReadyController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\Route;
use Spatie\Health\Http\Controllers\HealthCheckResultsController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
 */

Route::view('/', 'welcome');

require __DIR__.'/auth.php';

Route::middleware('auth')->group(function () {
    Route::view('/dashboard', 'dashboard')->name('dashboard');
    Route::get('/labels/create', [LabelController::class, 'create'])->name('labels.create');
    Route::get('/labels/{label}/configure', [LabelController::class, 'configure'])->name('labels.configure');
    Route::get('/sets/{set}/preview', [LabelController::class, 'preview'])->name('labels.preview');

    Route::get('/sets/{set}/generate', [LabelController::class, 'generate'])->name('labels.generate');

    Route::resource('users', UserController::class)->only('index', 'create', 'edit');

    Route::get('/activate/{user}/reset', [ActivationController::class, 'update'])->name('activation.update');

    Route::get('/activity/logs', [ActivityLogsController::class, 'index'])->name('activity_logs.index');

    Route::impersonate();
});

Route::get('/activate/{user:ott}', [ActivationController::class, 'index'])->name('activation.index');
Route::post('/activate/{user:ott}', [ActivationController::class, 'store'])->name('activation.store');

Route::get('/download/{token}', [ReadyController::class, 'download'])->name('download');

Route::get('health', HealthCheckResultsController::class)->name('health.index');

app/Http/Livewire/ActivityLogsTable.php
<?php

namespace App\Http\Livewire;

use App\Models\User;
use Livewire\Component;
use Livewire\WithPagination;
use Spatie\Activitylog\Models\Activity;

class ActivityLogsTable extends Component
{
    use WithPagination;

    /**
     * @var mixed
     */
    public $limit;

    public function updatingLimit()
    {
        $this->resetPage();
    }

    public function render()
    {
        $query = Activity::query();

        /**
         * @var User
         */
        $loggedUser = auth()->user();
        if (!$loggedUser->isAdmin()) {
            $query = Activity::causedBy($loggedUser);
        }

        $query->latest();

        return view('livewire.activity-logs-table', [
            'activity_logs' => $query->paginate($this->limit),
        ]);
    }

    public function subjectDisplay(Activity $log)
    {
        $display = $log->subject_type.' ('.$log->subject_id.')';
        if (isset($log->subject?->name) && $log->subject_type != 'App\Models\Field') {
            return '<span title="'.$display.'">'.$log->subject->name.'</span>';
        }

        return $display;
    }
}

app/Http/Livewire/DashboardCounts.php
<?php

namespace App\Http\Livewire;

use Livewire\Component;

class DashboardCounts extends Component
{
    public $labels;

    public $sets;

    public $fields;

    public $downloads;

    public $excludes;

    public function mount()
    {
        $user = auth()->user();
        $this->labels = $user->labels()->count();
        $this->sets = $user->sets()->count();
        $this->fields = $user->fields()->count();
        $this->downloads = $user->downloads()->count();
        $this->excludes = $user->excludes()->count();
    }

    public function render()
    {
        return view('livewire.dashboard-counts');
    }
}

app/Http/Livewire/ExcludeTable.php
<?php

namespace App\Http\Livewire;

use Livewire\Component;

class ExcludeTable extends Component
{
    public function render()
    {
        return view('livewire.exclude-table');
    }
}

app/Http/Livewire/FieldForm.php
<?php

namespace App\Http\Livewire;

use App\Models\Field;
use App\Models\Set;
use Livewire\Component;

class FieldForm extends Component
{
    public Set $set;

    public Field $field;

    public array $columns;

    public bool $isLast;

    protected $rules = [
        'field.name'          => 'required',
        'field.display_name'  => 'required',
        'field.type'          => 'required',
        'field.default'       => 'nullable',
        'field.settings.font' => 'required',
        'field.settings.type' => 'required',
        'field.settings.size' => 'required',
    ];

    public function updating($propertyName, $value)
    {
        $propertyName = str_replace('field.', '', $propertyName);
        if (
            $propertyName == 'name' && (
                empty(trim($this->field->display_name))
                || str_starts_with($this->field->display_name, 'Field ')
                || (isset($this->columns[$this->field->name])
                    && $this->field->display_name == $this->columns[$this->field->name])
            )
        ) {
            $this->field->display_name = $this->columns[$value];
        }
    }

    public function updated($propertName)
    {
        if ($this->field->type == 'EmptyRow') {
            $this->field->display_name = 'EmptyRow';
        }
        $this->field->save();
    }

    public function render()
    {
        $columns = ['NotSelected' => 'No Column'];

        foreach ($this->field->set->label->settings['columns'] as $index => $column) {
            $columns[$index] = $column;
        }
        $this->columns = $columns;

        return view('livewire.field-form', [
            'fontsConfig' => config('sai.fonts'),
            'fieldTypes'  => config('sai.fieldTypes'),
        ]);
    }

    public function destroy()
    {
        $this->field->delete();
        $this->emit('refreshSet');
    }

    public function moveUp()
    {
        $sequence = $this->field->sequence;
        if ($sequence == 1) {
            return;
        }

        $sequence--;

        $this->set->fields()->where('sequence', $sequence)->update([
            'sequence' => $this->field->sequence,
        ]);

        $this->field->sequence = $sequence;
        $this->field->save();
        $this->emit('refreshSet');
    }

    public function moveDown()
    {
        $sequence = $this->field->sequence;
        if ($sequence == $this->set->fields->count()) {
            return;
        }

        $sequence++;

        $this->set->fields()->where('sequence', $sequence)->update([
            'sequence' => $this->field->sequence,
        ]);

        $this->field->sequence = $sequence;
        $this->field->save();
        $this->emit('refreshSet');
    }
}

app/Http/Livewire/LabelConfigure.php
<?php

namespace App\Http\Livewire;

use App\Models\Label;
use App\Models\Set;
use Livewire\Component;

class LabelConfigure extends Component
{
    /**
     * @var mixed
     */
    public Label $label;

    public array $fontsConfig;

    protected $listeners = [
        'setDeleted' => 'refresh',
    ];

    protected $rules = [
        'label.settings.size'        => 'required',
        'label.settings.orientation' => 'required',
        'label.settings.numbers'     => 'required',
        'label.settings.column_nos'  => 'required',
        'label.settings.columns'     => 'nullable',
    ];

    public function mount($label)
    {
        $this->label = $label;
        $this->fontsConfig = config('sai.fonts');
    }

    /**
     * @param $property
     */
    public function updated($property)
    {
        if (str_starts_with($property, 'label.settings.')) {
            $this->label->save();
        }
    }

    public function addNewSet()
    {
        $set = new Set();
        $set->name = 'Label Set '.($this->label->sets()->count() + 1);
        $set->incremental = 1;

        $this->label->sets()->save($set);
        $this->refresh();
    }

    public function render()
    {
        return view('livewire.label-configure', [
            'pageOptions'      => array_merge(config('sai.pageOptions')),
            'pageOrientations' => array_merge(config('sai.pageOrientations')),
        ]);
    }

    public function refresh()
    {
        $this->label->refresh();
    }
}

app/Http/Livewire/LabelCreate.php
<?php

namespace App\Http\Livewire;

use App\Events\LabelCreated;
use App\Models\Label;
use Livewire\Component;
use Livewire\TemporaryUploadedFile;
use Livewire\WithFileUploads;

/**
 * @property TemporaryUploadedFile $path
 */
class LabelCreate extends Component
{
    use WithFileUploads;

    /**
     * @var mixed
     */
    public $name;

    /**
     * @var mixed
     */
    public $path;

    public $size;

    public $orientation;

    public $numbers;

    public $column_nos;

    public $templateList;

    public $template_id;

    /**
     * @var array
     */
    protected $rules = [
        'name'        => 'required',
        'path'        => 'mimes:csv,xls,xlsx',
        'size'        => 'required',
        'orientation' => 'required',
        'numbers'     => 'required',
        'column_nos'  => 'required',
        'template_id' => 'nullable|integer',
    ];

    public function mount()
    {
        $this->templateList = auth()->user()->templates()->select('name', 'id')->pluck('name', 'id')->toArray();
    }

    public function updatedPath()
    {
        $this->validate([
            'path' => 'mimes:csv,xls,xlsx',
        ]);
        $this->name = $this->path->getClientOriginalName();
    }

    public function submitForm()
    {
        $this->validate();

        $label = new Label();
        $label->name = $this->name;
        $label->path = $this->path->store('/uploads', 'public');
        $label->settings = [
            'size'        => $this->size,
            'orientation' => $this->orientation,
            'numbers'     => $this->numbers,
            'column_nos'  => $this->column_nos,
        ];
        auth()->user()->labels()->save($label);

        event(new LabelCreated($label, $this->template_id));

        return redirect()->route('labels.configure', [
            'label' => $label->id,
        ]);
    }

    public function render()
    {
        return view('livewire.label-create', [
            'pageOptions'      => array_merge(config('sai.pageOptions')),
            'pageOrientations' => array_merge(config('sai.pageOrientations')),
        ]);
    }
}

app/Http/Livewire/LabelTable.php
<?php

namespace App\Http\Livewire;

use Livewire\Component;
use Livewire\WithPagination;

class LabelTable extends Component
{
    use WithPagination;

    /**
     * @var mixed
     */
    public $limit;

    public function updatingLimit()
    {
        $this->resetPage();
    }

    public function render()
    {
        $user = auth()->user();

        return view('livewire.label-table', [
            'labels' => $user->labels()->latest()->paginate($this->limit),
        ]);
    }
}

app/Http/Livewire/SaveTemplate.php
<?php

namespace App\Http\Livewire;

use App\Models\Label;
use App\Models\Template;
use Livewire\Component;

class SaveTemplate extends Component
{
    public Label $label;

    public Template $template;

    public $rules = [
        'template.name' => 'required',
    ];

    public function mount()
    {
        if (isset($this->label->template)) {
            $this->template = $this->label->template;
        } else {
            $this->template = new Template();
        }
    }

    public function render()
    {
        return view('livewire.save-template');
    }

    public function submit()
    {
        $this->validate();

        $this->label->load('sets', 'sets.fields');
        $this->template->user_id = auth()->id();
        $this->template->options = $this->label->sets;
        $this->template->save();

        $this->label->template_id = $this->template->id;
        $this->label->save();

        $this->emit('showSuccess', 'Templated saved!');
    }
}

app/Http/Livewire/SetForm.php
<?php

namespace App\Http\Livewire;

use App\Jobs\GeneratePDFJob;
use App\Models\Field;
use App\Models\Set;
use Livewire\Component;

class SetForm extends Component
{
    public Set $set;

    public array $columns;

    public string $previewLink;

    protected $rules = [
        'set.name'                   => 'required',
        'set.type'                   => 'required',
        'set.columnName'             => 'nullable',
        'set.limit'                  => 'nullable|numeric',
        'set.incremental'            => 'nullable|numeric',
        'set.header_width'           => 'nullable|numeric',
        'set.header_font'            => 'nullable|numeric',
        'set.settings.columns'       => 'nullable',
        'set.settings.differentPage' => 'nullable',
        'set.settings.fragile'       => 'nullable|boolean',
        'set.settings.filter'        => 'nullable',
    ];

    protected $listeners = [
        'refreshSet'  => 'refresh',
        'hidePreview' => 'hide',
    ];

    public function updated($name, $value)
    {
        if ($name == 'set.limit' && empty($value)) {
            $this->set->limit = null;
        }
        $this->set->save();
    }

    public function render()
    {
        $columns = ['NotSelected' => ''];
        foreach ($this->set->label->settings['columns'] ?? [] as $column) {
            $columns[] = $column;
        }
        $this->columns = $columns;

        return view('livewire.set-form');
    }

    public function generatePDF()
    {
        GeneratePDFJob::dispatch($this->set);
        $this->emit('showSuccess', 'PDF generation added to queue, you should receive email shortly!');
    }

    public function hide()
    {
        $this->previewLink = false;
    }

    public function previewPDF()
    {
        // $this->previewLink = route('labels.preview', ['set' => $this->set->id]);
        $this->emit('openLink', route('labels.preview', ['set' => $this->set->id]));
    }

    public function openWebPage()
    {
        $this->emit('openLink', route('labels.generate', ['set' => $this->set->id]));
    }

    public function destroy()
    {
        $this->set->delete();
        $this->emit('setDeleted');
    }

    public function addField()
    {
        $field = new Field();
        $field->name = 'Field '.$this->set->fields->count() + 1;
        $field->display_name = $field->name;
        $field->type = 'Text';
        $field->settings = [
            'font' => 'Roboto',
            'type' => 'Regular',
            'size' => '15',
        ];
        $field->sequence = $this->set->fields()->count() + 1;
        $this->set->fields()->save($field);
        $this->refresh();
    }

    public function refresh()
    {
        $this->set->refresh();
    }
}

app/Http/Livewire/UserForm.php
<?php

namespace App\Http\Livewire;

use App\Models\User;
use Illuminate\Support\Str;
use Livewire\Component;

class UserForm extends Component
{
    public User $user;

    protected array $rules = [
        'user.name'    => 'required',
        'user.email'   => 'required|email',
        'user.company' => 'nullable',
        'user.level'   => 'required',
    ];

    public function render()
    {
        return view('livewire.user-form', [
            'levels' => [
                'user'  => 'User',
                'admin' => 'Admin',
            ],
        ]);
    }

    public function submitForm()
    {
        if (!$this->user->password) {
            $this->user->password = Str::random();
        }
        $this->validate();

        $this->user->save();

        session()->flash('success', 'User details saved successfully');

        return redirect()->route('users.index');
    }
}

app/Http/Livewire/UsersTable.php
<?php

namespace App\Http\Livewire;

use App\Models\User;
use Livewire\Component;
use Livewire\WithPagination;

class UsersTable extends Component
{
    use WithPagination;

    /**
     * @var mixed
     */
    public $limit;

    public function updatingLimit()
    {
        $this->resetPage();
    }

    public function render()
    {
        return view('livewire.users-table', [
            'users' => User::withCount('labels', 'sets', 'downloads')->paginate($this->limit),
        ]);
    }
}

resources/views/livewire/activity-logs-table.blade.php
<div>
    <div class="w-full bg-white bg-white shadow p-2 inline-block rounded-lg">
        <table class="table-auto w-full">
            <thead class="bg-gray-200">
                <tr>
                    <th>User</th>
                    <th>Event</th>
                    <th>Subject</th>
                    <th>Description</th>
                    <th></th>
                </tr>
            </thead>
            <tbody>
                @foreach ($activity_logs as $log)
                    <tr class="hover:bg-gray-100 p-2">
                        <td>{{ $log->causer?->name }}</td>
                        <td>{{ $log->event }}</td>
                        <td>{!! $this->subjectDisplay($log) !!}</td>
                        <td>{{ $log->description }}</td>
                        <td x-data="{ showProperties: false, properties: {{ $log->properties }}}">
                            <x-small-button @click="showProperties = true">
                                <x-icon.eye></x-icon.eye>
                            </x-small-button>
                        </td>
                    </tr>
                @endforeach
            </tbody>
        </table>
        <div>
            {{ $activity_logs->links() }}
        </div>
    </div>
</div>

resources/views/livewire/dashboard-counts.blade.php
<div class="flex justify-between">
    <div class="w-1/3 mr-1 bg-white overflow-hidden shadow-sm sm:rounded-lg">
        <div class="p-6  bg-white border-b border-gray-200 flex justify-between">
            <div>Labels</div>
            <div class="text-2xl font-semibold">{{ $labels }}</div>
        </div>
    </div>
    <div class="w-1/3 mr-1 bg-white overflow-hidden shadow-sm sm:rounded-lg">
        <div class="p-6  bg-white border-b border-gray-200 flex justify-between">
            <div>Sets</div>
            <div class="text-2xl font-semibold">{{ $sets }}</div>
        </div>
    </div>
    <div class="w-1/3 mr-1 bg-white overflow-hidden shadow-sm sm:rounded-lg">
        <div class="p-6  bg-white border-b border-gray-200 flex justify-between">
            <div>Fields</div>
            <div class="text-2xl font-semibold">{{ $fields }}</div>
        </div>
    </div>
    <div class="w-1/3 mr-1 bg-white overflow-hidden shadow-sm sm:rounded-lg">
        <div class="p-6  bg-white border-b border-gray-200 flex justify-between">
            <div>Downloads</div>
            <div class="text-2xl font-semibold">{{ $downloads }}</div>
        </div>
    </div>
    <div class="w-1/3 ml-1 bg-white overflow-hidden shadow-sm sm:rounded-lg">
        <div class="p-6  bg-white border-b border-gray-200 flex justify-between">
            <div>Excludes</div>
            <div class="text-2xl font-semibold">{{ $excludes }}</div>
        </div>
    </div>
</div>

resources/views/livewire/exclude-table.blade.php
<div>
    {{-- Be like water. --}}
</div>

resources/views/livewire/field-form.blade.php
<div class="flex bg-yellow-100 justify-between mt-2 rounded-lg pt-2 pb-2 pr-2">
    <div class="w-8 self-center rounded-t-lg rounded-b-lg bg-yellow-200 cursor-move min-h-full mr-1 -mt-2">
        <div>#{{ $field->sequence }}</div>
        <div>
            @if ($field->sequence > 1)
                <a href="#" wire:click.prevent="moveUp">
                    <x-icon.up></x-icon.up>
                </a>
            @endif
            @if (!$isLast)
                <a href="#" wire:click.prevent="moveDown">
                    <x-icon.down></x-icon.down>
                </a>
            @endif
        </div>
    </div>
    <div class="w-2/12">
        <x-label>Field Type</x-label>
        <x-select wire:model="field.type" :options="$fieldTypes" class="w-10/12" />
    </div>
    <div class="w-3/12">
        <x-label>Field Name</x-label>
        <x-select wire:model.debounce.500ms="field.name" :options="$columns" type="text" class="w-10/12" />
    </div>
    <div class="w-3/12">
        <x-label>Display Name</x-label>
        <x-input :disabled="$field->type == 'EmptyRow'" wire:model.debounce.500ms="field.display_name" type="text"
            class="w-10/12" />
    </div>
    <div class="w-2/12">
        <x-label>Field Font</x-label>
        <select disabled wire:model="field.settings.font" class="w-10/12 select">
            @foreach ($fontsConfig as $fontKey => $font)
                <option value="{{ $fontKey }}">{{ $font['name'] }}</option>
            @endforeach
        </select>
    </div>
    <div class="w-2/12">
        <x-label>Font Weight</x-label>
        <select disabled wire:model="field.settings.type" class="w-10/12 select">
            @foreach ($fontsConfig[$field->settings['font']]['weight'] as $weightKey => $weightValue)
                <option value="{{ $weightKey }}">{{ $weightValue }}</option>
            @endforeach
        </select>
    </div>
    <div class="w-1/12">
        <x-label>Font Size</x-label>
        <x-input wire:model.debouce.500ms="field.settings.size" type="number" step="1" min="6" class="w-10/12" />
    </div>
    @if ($field['type'] == 'Static')
        <div class="w-2/12">
            <x-label>Static Value</x-label>
            <x-input wire:model.debounce.500ms="field.default" type="text" class="w-10/12" />
        </div>
    @else
        <div class="w-2/12"></div>
    @endif
    <div class="w-1/12">
        <x-button class="mt-6" wire:click="destroy">
            <x-icon.trash></x-icon.trash>
            Delete
        </x-button>
    </div>
</div>

resources/views/livewire/label-configure.blade.php
<div>
    <x-container>
        <div class="flex justify-between">
            <div class="w-10/12 flex flex-wrap space-x-2">
                <div class="w-1/4 px-2">
                    <x-label for="size" :value="__('Page Size')" />
                    <x-select wire:model="label.settings.size" id="size" class="block mt-1 w-full"
                        :options="$pageOptions" />
                    @error('size')
                        <span class="error">{{ $message }}</span>
                    @enderror
                </div>
                <div class="w-1/4 px-2">
                    <x-label for="orientation" :value="__('Page Orientation')" />
                    <x-select wire:model="label.settings.orientation" id="orientation" class="block mt-1 w-full"
                        :options="$pageOrientations" />
                    @error('orientation')
                        <span class="error">{{ $message }}</span>
                    @enderror
                </div>
                <div class="w-1/4 px-2">
                    <x-label for="numbers" :value="__('Page Number')" />
                    <x-select wire:model="label.settings.numbers" id="numbers" class="block mt-1 w-full"
                        :options="['0' => 'No', '1' => 'Yes']" />
                    @error('numbers')
                        <span class="error">{{ $message }}</span>
                    @enderror
                </div>
                <div class="w-1/5 px-2">
                    <x-label for="column_nos" :value="__('Page Columns')" />
                    <x-select wire:model="label.settings.column_nos" id="column_nos" class="block mt-1 w-full"
                        :options="[1 => 1, 2 => 2, 3 => 3, 4 => 4]" />
                    @error('column_nos')
                        <span class="error">{{ $message }}</span>
                    @enderror
                </div>
            </div>
            <div class="pt-4">
                <x-button wire:click="addNewSet">
                    <x-icon.add class="w-6 h-6 mr-1"></x-icon.add>
                    Add New Set
                </x-button>
            </div>
        </div>
    </x-container>

    @foreach ($label->sets as $index => $set)
        @livewire('set-form', ['set' => $set], key($set->id))
    @endforeach
</div>

resources/views/livewire/label-create.blade.php
<div>
    <x-container>
        <form wire:submit.prevent="submitForm" method="post">

            <div class="flex space-x-4 mt-2">

                <div class="w-4/12 mt-2">
                    <x-label for="path" :value="__('Select Excel')" />
                    <x-input wire:model.debounce.500ms="path" class="block border p-1 mt-1 w-full" type="file"
                        required />
                    @error('path')
                        <span class="error">{{ $message }}</span>
                    @enderror
                </div>

                <div class="w-8/12 mt-2">
                    <x-label for="name" :value="__('Name')" />
                    <x-input wire:model.defer="name" class="block mt-1 w-full" type="text" required autofocus />
                    @if ($errors->has('name'))
                        <span class="error">{{ $errors->name }}</span>
                    @endif
                </div>
            </div>

            <div class="flex space-x-4 mt-2">
                <div class="w-4/12 ">
                    <x-label for="size" :value="__('Page Size')" />
                    <x-select wire:model.defer="size" id="size" class="block mt-1 w-full" :options="$pageOptions" />
                    @error('size')
                        <span class="error">{{ $message }}</span>
                    @enderror
                </div>
                <div class="w-4/12">
                    <x-label for="orientation" :value="__('Page Orientation')" />
                    <x-select wire:model.defer="orientation" id="orientation" class="block mt-1 w-full"
                        :options="$pageOrientations" />
                    @error('orientation')
                        <span class="error">{{ $message }}</span>
                    @enderror
                </div>
                <div class="w-4/12">
                    <x-label for="numbers" :value="__('Page Number')" />
                    <x-select wire:model.defer="numbers" id="numbers" class="block mt-1 w-full"
                        :options="['0' => 'No', '1' => 'Yes']" />
                    @error('numbers')
                        <span class="error">{{ $message }}</span>
                    @enderror
                </div>
                <div class="w-4/12">
                    <x-label for="column_nos" :value="__('Page Columns')" />
                    <x-select wire:model.defer="column_nos" id="column_nos" class="block mt-1 w-full"
                        :options="[1 => 1, 2 => 2, 3 => 3, 4 => 4]" />
                    @error('column_nos')
                        <span class="error">{{ $message }}</span>
                    @enderror
                </div>
            </div>
            @if(isset($templateList) && count($templateList) > 0)
                <div class="flex mt-2">
                    <div class="w-1/3">
                        <x-label for="template_id" :value="__('Create from Template')" />
                        <x-select wire:model.defer="template_id" :options="$templateList"></x-select>
                    </div>
                </div>
            @endif
            <x-button class="mt-4">
                <svg wire:loading class="animate-spin mr-3 h-5 w-5 text-white" xmlns="http://www.w3.org/2000/svg"
                    fill="none" viewBox="0 0 24 24">
                    <circle class="opacity-25" cx="12" cy="12" r="10" stroke="currentColor" stroke-width="4">
                    </circle>
                    <path class="opacity-75" fill="currentColor"
                        d="M4 12a8 8 0 018-8V0C5.373 0 0 5.373 0 12h4zm2 5.291A7.962 7.962 0 014 12H0c0 3.042 1.135 5.824 3 7.938l3-2.647z">
                    </path>
                </svg>
                Submit
            </x-button>
        </form>
    </x-container>
</div>

resources/views/livewire/users-table.blade.php
<div>
    <div class="w-full bg-white bg-white shadow p-2 inline-block rounded-lg">
        <table class="table-auto">
            <thead class="bg-gray-200">
                <tr class="rounded-t-lg">
                    <th class="py-1 w-2/12">Name</th>
                    <th class="py-1 w-1/12">Email</th>
                    <th class="py-1 w-1/12">Company</th>
                    <th class="py-1 w-1/12">Email Verified</th>
                    <th class="py-1 w-2/12">Joined</th>
                </tr>
            </thead>
            <tbody>
                @foreach ($users as $user)
                    {{-- <tr>
                                <td colspan="8">{{ json_encode($label) }}</td>
                            </tr> --}}
                    <tr class="hover:bg-gray-100">
                        <td class="p-2">
                            <div class="my-2">
                                <a href="{{ route('users.edit', ['user' => $user->id]) }}">
                                    <x-icon.edit></x-icon.edit>
                                </a>
                                <a href="{{ route('activation.update', ['user' => $user->id]) }}">
                                    <x-icon.lock></x-icon.lock>
                                </a>
                                <a href="{{ route('impersonate', $user->id) }}">
                                    <x-icon.login></x-icon.login>
                                </a>
                                <span class="text-xl">{{ $user->name }}</span>
                                @if($user->id == auth()->user()->id)
                                <span class="font-thin">(You)</span>
                                @endif
                            </div>
                            <div class="flex mb-1">
                                <div class="inline-flex shadow-md hover:shadow-lg focus:shadow-lg btn-group"
                                    role="group">
                                    <button type="button" class="btn-sm px-3">
                                        Labels <span class="bg-blue-900 ml-1 px-1">{{ $user->labels_count }}</span>
                                    </button>
                                    <button type="button" class="btn-sm px-3">
                                        Sets <span class="bg-blue-900 ml-1 px-1">{{ $user->sets_count }}</span>
                                    </button>
                                    <button type="button" class="btn-sm px-3">
                                        Downloads <span
                                            class="bg-blue-900 ml-1 px-1">{{ $user->downloads_count }}</span>
                                    </button>
                                </div>
                            </div>
                        </td>
                        <td class="text-center text-sm">{!! $user->email !!}</td>
                        <td class="text-center text-sm">{!! $user->company !!}</td>
                        <td class="text-center text-sm">{{ $user->email_verified_at }}</td>
                        <td class="text-center text-sm">{{ $user->created_at->diffForHumans() }}</td>
                    </tr>
                @endforeach
            </tbody>
        </table>
        <div>
            {{ $users->links() }}
        </div>
    </div>
</div>